<?php

/*

Plugin Name: GA Made Simple

Plugin URI: http://www.devictio.fr

Version: 2.0

Description: Add Google Analytics code on each pages

Author: Nicolas Grillet

Author URI: http://www.devictio.fr

Network: true

Text Domain: ga-made-simple

Domain Path: /languages

*/

/*  Copyright 2014  Nicolas Grillet  (email : n.grillet01[@]gmail.com)



    This program is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License, version 2, as 

    published by the Free Software Foundation.



    This program is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with this program; if not, write to the Free Software

    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

load_plugin_textdomain('ga-made-simple', false, basename( dirname( __FILE__ ) ) . '/languages' );

function ga_order_ok($id_order){
	if(get_option("woocommerce")==1){
		if(get_option("universal")==1){
			$order=new WC_Order($id_order);
			$s=explode(',',$order->get_billing_address());
			echo "<script>
			ga('require', 'ecommerce');
			ga('ecommerce:addTransaction', {
			  'id': '".$id_order."',
			  'affiliation': '".get_bloginfo('name')."',
			  'revenue': '".($order->get_total()-$order->get_total_shipping())."',
			  'shipping': '".$order->get_total_shipping()."',
			  'tax': '".$order->get_total_tax()."'
			});";
			if ( count( $order->get_items() ) > 0 ) {
			  foreach( $order->get_items() as $item ) {
				  $p=new WC_Product($item['product_id']);
				 echo "
				 ga('ecommerce:addItem', {
				  'id': '".$id_order."',
				  'name': '".$item['name']."',
				  'sku': '".$item['product_id']."',
				  'category': '".strip_tags($p->get_categories())."',
				  'price': '".($item['line_total']/$item['qty'])."',
				  'quantity': '".$item['qty']."'
				});";
			  }
			}
			echo "ga('ecommerce:send');</script>";
		}else{
			$order=new WC_Order($id_order);
			$s=explode(',',$order->get_billing_address());
			echo "<script>
			_gaq.push(['_addTrans',
				'".$id_order."',
				'".get_bloginfo('name')."', 
				'".($order->get_total()-$order->get_total_shipping())."', 
				'".$order->get_total_tax()."',
				'".$order->get_total_shipping()."',
				'".trim($s[sizeof($s)-3])."',
				'',
				'".trim($s[sizeof($s)-1])."' 
			]);";
			if ( count( $order->get_items() ) > 0 ) {
			  foreach( $order->get_items() as $item ) {
				  $p=new WC_Product($item['product_id']);
				 echo "
				 _gaq.push(['_addItem',
					'".$id_order."', 
					'".$item['product_id']."',
					'".$item['name']."',
					'".strip_tags($p->get_categories())."',
					'".($item['line_total']/$item['qty'])."',
					'".$item['qty']."'
				]);";
			  }
			}
			echo "_gaq.push(['_trackTrans']);</script>";
		}
	}
}

function ga_made_simple(){
	echo "<!-- Google Analytics Tracking with Devictio Plugin http://www.devictio.fr -->\n";

	if(strlen(get_option("ua_code"))>=9){
		if(get_option("universal")==1){
			echo "<script>
			var author_url='http://www.devictio.fr';
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
  ga('create', '".get_option("ua_code")."', 'auto');";
  				if(get_option("display")==1){
					echo "ga('require', 'displayfeatures');";
				}
		  echo "ga('send', 'pageview');
		</script>";
			
		}else{

	echo "<script type=\"text/javascript\">\n
			var author_url='http://www.devictio.fr';
  var _gaq = _gaq || [];\n";

  	echo "_gaq.push(['_setAccount', '".get_option("ua_code")."']);\n";

	if(get_option("sub_domain")==1||get_option("many_domain")==1)

  		echo "_gaq.push(['_setDomainName', '".$_SERVER['HTTP_HOST ']."']);\n";

	if(get_option("many_domain")==1)

 		echo "_gaq.push(['_setAllowLinker', true]);\n";

	if(get_option("campain")==1)

		echo "_gaq.push(['_setCampNameKey', 'utm_name']);\n";

	echo "_gaq.push(['_trackPageview']);\n";

	echo "(function() {\n

    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;\n";

	if(get_option("display")==1){

    	echo "ga.src = ('https:' == document.location.protocol ? 'https://' : 'http://') + 'stats.g.doubleclick.net/dc.js';\n";

	}else{

		echo "ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';\n";

	}

    echo "var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);\n

  })();\n

</script>";	
		}

	}else{

		echo "\n<!-- WARNING : Please go to GA Made Simple settings -->";

	

	}

}

add_action('wp_head', 'ga_made_simple');



add_action( 'admin_menu', 'ga_ms_menu' );

function ga_ms_menu(){

	add_menu_page( 'GA Made Simple by Devictio', 'GA Made Simple', 'manage_options', 'ga_ms_menu', 'ga_ms_admin_page', 'dashicons-chart-area', 99 ); 

}

function ga_ms_admin_page() {

	if(isset($_POST["submit"])){ 

		update_option( 'universal',$_POST['universal'] );
		
		update_option( 'ua_code',$_POST['ua_code'] );

		update_option( 'sub_domain',$_POST['sub_domain'] );

		update_option( 'many_domain',$_POST['many_domain'] );

		update_option( 'display',$_POST['display'] );

		update_option( 'campain',$_POST['campain'] );

		update_option( 'woocommerce',$_POST['woocommerce'] );

	}else{

		if ( is_admin() ){ 

			register_setting( 'gams-group', 'universal' );
			
			register_setting( 'gams-group', 'ua_code' );

			register_setting( 'gams-group', 'sub_domain' );

			register_setting( 'gams-group', 'many_domain' );

			register_setting( 'gams-group', 'display' );

			register_setting( 'gams-group', 'campain' );

			register_setting( 'gams-group', 'woocommerce' );

		}

	}

	if ( !current_user_can( 'manage_options' ) )  {

		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );

	}

	echo '<form method="post" action=""><input type="hidden" name="option_page" value="reading"><input type="hidden" name="action" value="update">'; 

	settings_fields( 'ga_ms_menu' );

	do_settings_sections( 'ga_ms_admin_page' );   

	echo '<div class="wrap">';

	echo '<h2>'.__("GA Made Simple Settings","ga-made-simple").'</h2><table class="form-table"><tbody>';

	echo '<tr valign="top"><th scope="row">'.__("Tracking ID (eg : UA-xxxxxx)","ga-made-simple").'</th><td><fieldset><p><input name="ua_code" type="text" value="'.get_option('ua_code').'" class="tog"></p></fieldset></td></tr>';
	
	echo '<tr valign="top"><th scope="row">'.__("Use universal code ?","ga-made-simple").'</th><td><fieldset><p><label><input name="universal" type="radio" value="1"'.(get_option('universal')==1?' checked':'').' class="tog">'.__('yes',"ga-made-simple").'</label>&nbsp;&nbsp;<label><input name="universal" type="radio" class="tog" value="0"'.(get_option('universal')==0?' checked':'').'>'.__('no',"ga-made-simple").'</label></p></fieldset></td></tr>';

	echo '<tr valign="top"><th scope="row">'.__("Sub domains ?","ga-made-simple").'</th><td><fieldset><p><label><input name="sub_domain" type="radio" value="1"'.(get_option('sub_domain')==1?' checked':'').' class="tog">'.__('yes',"ga-made-simple").'</label>&nbsp;&nbsp;<label><input name="sub_domain" type="radio" class="tog" value="0"'.(get_option('sub_domain')==0?' checked':'').'>'.__('no',"ga-made-simple").'</label></p></fieldset></td></tr>';

	echo '<tr valign="top"><th scope="row">'.__("Several domains ?","ga-made-simple").'</th><td><fieldset><p><label><input name="many_domain" type="radio" value="1"'.(get_option('many_domain')==1?' checked':'').' class="tog">'.__('yes',"ga-made-simple").'</label>&nbsp;&nbsp;<label><input name="many_domain" type="radio" class="tog" value="0"'.(get_option('many_domain')==0?' checked':'').'>'.__('no',"ga-made-simple").'</label></p></fieldset></td></tr>';

	echo '<tr valign="top"><th scope="row">'.__("Tags personalized campaigns","ga-made-simple").'</th><td><fieldset><p><label><input name="campain" type="radio" value="1"'.(get_option('campain')==1?' checked':'').' class="tog">'.__('yes',"ga-made-simple").'</label>&nbsp;&nbsp;<label><input name="campain" type="radio" class="tog" value="0"'.(get_option('campain')==0?' checked':'').'>'.__('no',"ga-made-simple").'</label></p></fieldset></td></tr>';

	echo '<tr valign="top"><th scope="row">'.__("Assistance for advertisers Display Network ?","ga-made-simple").'</th><td><fieldset><p><label><input name="display" type="radio" value="1"'.(get_option('display')==1?' checked':'').' class="tog">'.__('yes',"ga-made-simple").'</label>&nbsp;&nbsp;<label><input name="display" type="radio" class="tog" value="0"'.(get_option('display')==0?' checked':'').'>'.__('no',"ga-made-simple").'</label></p></fieldset></td></tr>';
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
	echo '<tr valign="top"><th scope="row">'.__("Enable for woocommerce ?","ga-made-simple").'</th><td><fieldset><p><label><input name="woocommerce" type="radio" value="1"'.(get_option('woocommerce')==1?' checked':'').' class="tog">'.__('yes',"ga-made-simple").'</label>&nbsp;&nbsp;<label><input name="woocommerce" type="radio" class="tog" value="0"'.(get_option('woocommerce')==0?' checked':'').'>'.__('no',"ga-made-simple").'</label></p></fieldset></td></tr>';
}
	echo '</tbody></table></div>';

	submit_button();

	echo '</form></div>';

}
if(get_option("woocommerce")==1&&in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins')))){
	add_action( 'woocommerce_thankyou', "ga_order_ok");
}
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'liens_pages_extensions_gams' );
function liens_pages_extensions_gams( $links ) {
   $links[] = '<a href="http://www.devictio.fr target="_blank">www.devictio.fr <img src="http://apps.devictio.fr/GA_Made_Simple.png" alt="logo" /></a>';
   return $links;
}

